(*Ŀ
  Source                                                                  
                                                                  
                    ---- Source : ??? (je ne l'ai pas note) ---            
                                                                            
                               Amlior par :                               
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $$$  $$$  $  $    $$$$   $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$     $$   $   $  $o  $'  $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$  $  $$   $   $  $7 $  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$       $$     $$$     $$    $$  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $   $   $$$   $$$  $$$$$   $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $ $$$ $$$  $$$ $$$$$$    $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ http://www.haypo.fr.st/ $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ haypo@ifrance.com $
Ĵ
  Info                                                                    
                                                                    
                                                                            
           Lit un son au format WAV sur une carte son Sound Blaster.        
*)

{$M 4096,0,65500}
{$G+ :Utilise les fonctions du 286 : SHL & SHR (multiplication ultra rapide) }

Uses DOS,EcranTxt,Convert,FaitPaus,Clavier,GestFich;

const
  NomFich   = 'poubelle.wav';
  _DmaDefaut = $220;

Type
  Signature4ch   = Array[1..4] of Char;

  TypeEnteteRIFF = Record
    SignatureRIFF: Signature4ch;       { = 'RIFF'                            }
    Longueur: Longint;                 { Longueur du son                     }
    SignatureWAVE: Signature4ch;       { = 'WAVE'                            }
    SignatureFMT_: Signature4ch;       { = 'FMT '                            }
    s_length: Longint;
    Format,
    NbrCanaux: Word;                   { =2 : Stro, =1: Mono               }
    Frequence,                         { en Hertz (Hz)                       }
    OctetParSec: LongInt;              { Octet/seconde                       }
    byte_sam,
    NbrBit: Word;                      { 8-bit, 16-bit                       }
    D_Ident : Signature4ch;
    TailleRaw: LongInt;                { Taille RAW (des donnes) en octet   }
  End;

  blaster_T = Record
    port : Word;
    dmac ,
    hdmac,
    irq  : Byte;
  End;

  buffer_T = Array[1.._DmaDefaut] of Byte;

Var
  EnteteRiff: TypeEnteteRiff;
  txt: String;
  F: File;
  SauveInt: Pointer;
  PortSB: Word;
    Ende     : Boolean;
    blaster  : Blaster_T;
    dma_buf_1,
    dma_buf_2,
    zwi      : ^Buffer_T;
    Channel  : Byte;

Const
  RIFF : Signature4ch = ('R','I','F','F');
  WAVE : Signature4ch = ('W','A','V','E');
  FMT_ : Signature4ch = ('f','m','t',' ');
  DATA : Signature4ch = ('d','a','t','a');

  DMA_Dat : Array [0..7,1..6] of Byte= (
    ($A,$C,$B,$0,$87,$1),
    ($A,$C,$B,$2,$83,$3),
    ($A,$C,$B,$4,$81,$5),
    ($A,$C,$B,$6,$82,$7),
    ($D4,$D8,$D6,$C0,$8F,$C2),
    ($D4,$D8,$D6,$C4,$8B,$C6),
    ($D4,$D8,$D6,$C8,$89,$CA),
    ($D4,$D8,$D6,$CC,$8A,$CE));

Procedure Blaster_Command (commande :Byte); Assembler; Asm
  Mov dx,[PortSB]
  Add dx,$c
@t:
  In al,dx
  And al,128
  Jnz @t

  Mov al,[commande]
  Out dx,al
End;

Procedure InitPortSB (base : Word);
Var w,w2:Word;
Begin
  PortSB := base;
  Port[base+6]:=1; Pause(4); Port[base+6]:=0; w:=0; w2:=0;
  Repeat
    Repeat Inc(w); Until ((Port[base+$e] and 128)=128) or (w>29);
    Inc(w2);
  Until (Port[base+$a]=$AA) or (W2>30);

  If w2>30 then begin
    SauteLigne;
    EcriTcr ('Echec lors de la rinitialisation de la Sound Blaster !',14+4*16);
    Halt(128);
  End;
  Blaster_Command($d1);
End;

Procedure SB_PasseStereo; Assembler; Asm
  Mov dx,[PortSB]
  Add dx,4

  Mov al,0Eh
  Out dx,al
  Inc dx

  in al,dx
  or al,2
  Out dx,al
End;

Procedure SB_DesactiveStereo; Assembler; asm
  mov dx,[PortSB]
  add dx,$4
  mov al,$e
  out dx,al                  { Fonction 0Eh : ? (format des sons WAV)        }

  inc dx
  in al,dx
  and al,253                 { bit #2 : FALSE (mode stro)                  }
  out dx,al
End;

Function SonWavIncorrect (Var id: TypeEnteteRiff):Boolean; begin
  With id do SonWavIncorrect :=
    (SignatureRIFF<>RIFF) or
    (SignatureWAVE<>WAVE) or
    (SignatureFMT_<>FMT_) or
    (D_Ident<>DATA);
End;

procedure InitSB; var b: Byte; env: String; begin
  env := GetEnv('BLASTER');
  If env='' then Begin
    EcriTcr ('L''environnement BLASTER doit tre configur !',12);
    EcriTr ('(SET BLASTER=... dans le fichier ''C:\autoexec.bat)''.');
    SauteLigne;
    EcriTcr ('Le programme utilise les paramtres par dfaut :',10);
{    Halt (100);}
    Blaster.Port  := $220;
    Blaster.dmac  := $1;
    Blaster.hdmac := $5;
    Blaster.irq   := $5;
  End else begin
    Blaster.Port  := 0;
    Blaster.dmac  := 0;
    Blaster.hdmac := 0;
    Blaster.irq   := 0;

    b := 1;
    Repeat
      Case env[b] of
      'A' { Port } : Repeat
         Inc(b);
         Blaster.Port:=Blaster.Port*16+Ord(env[b])-48;
      Until env[b+1]=' ';

      'D' {DMAc } : Begin
         Blaster.DMAc:=Ord(env[b+1])-48;
         Inc(b,2);
      End;

      'I' {IRQ} : Repeat
         Inc(b);
         Blaster.IRQ:=Blaster.IRQ*16+Ord(env[b])-48;
      Until env[b+1]=' ';

      'H' {DMA HIGH }: Begin
         Blaster.hDMAc := Ord(env[b+1])-48;
         Inc(b,2);
      End End;

      Inc(b);
    Until b>Length(env);
  end;

  { Affiche les paramtres }
  With Blaster do begin
    EcriTc ('Blaster : ',15);
    Ecrit ('Port='); EcriTc (Hex16(Port),10);
    Ecrit (' IRQ='); EcriTnc (IRQ,10);
    Ecrit (' DMA='); EcriTc (Hex16(DmaC),10);
    Ecrit (' DMA HIGH='); EcriTcr (Hex16(HDmaC),10);
  end;

  InitPortSB (Blaster.Port);
end;

Procedure Init; Begin
  EffaceEcranTxt;
  EcriTcr ('ABo WAV-Player (16bit Test)      (p) 27.11.1994 ABo',15);
  SauteLigne;

  EcriTc ('Fichier : ',15); EcriTcr (NomFich,10);
  txt := NomFich;
  TestErreurFich (OuvreFichier (F, _LectureSeule, txt, 'wav'),'ouverture du son wave',txt);

  BlockRead(F,EnteteRiff,Sizeof(TypeEnteteRiff));
  If SonWavIncorrect (EnteteRiff) then Begin
    EcriTcr ('Le son "'+NomFich+'" ne semble pas tre un fichier son au format WAV ...',12);
    Halt (1);
  End;

  EcriTc ('Son WAV : ',15); EcriTnc (EnteteRiff.NbrBit,10); Ecrit ('-bit ');
  If EnteteRiff.NbrCanaux=2 then Begin
    SB_PasseStereo;
    EcriTc ('Stro ',10);
  End Else Begin
    SB_DesactiveStereo;
    EcriTc ('Mono ',10);
  End;

  EcriTnc (EnteteRiff.Frequence,10); Ecrit (' Hz  ');
  EcriTnc (EnteteRiff.OctetParSec,10); EcriTr (' Octets/seconde');

  { Affiche la taille du son }
  EcriTc ('Taille  : ',15); EcriTnc (EnteteRiff.TailleRAW,10); Ecrit (' octets -> ');
  Str (EnteteRiff.TailleRAW/EnteteRiff.OctetParSec:4:2,txt);
  EcriTc (txt,10); EcriTr (' seconde(s)');

  InitSB;

  If (EnteteRiff.NbrBit>8) and (Blaster.hdmac>3) then
    Channel:=Blaster.hdmac
  Else
    Channel:=Blaster.dmac;

  SauteLigne;
End;

{$F+}

{ Dsactive les interruptions masquables }
Procedure CLI; inline($FA);

{ Ractive les interruptions masquables }
Procedure STI; inline($FB);

Procedure Stelle_DMA (Freq: Word; Var size: Word);
Var PageNr,PageAdress,DMALength: Word;
Begin
  CLI;

  Asm
    mov ax,[DMA_Buf_1[2]].word
    shr ax,12
    mov [PageNr],ax

    Mov ax,[DMA_Buf_1[2]].word
    shl ax,4
    Mov [PageAdress],ax

    Mov ax,[DMA_Buf_1].word
    Add [PageAdress],ax
    Adc [PageNr],0
  End;

  DMALength := Size;
  Freq := 256-Trunc(1000000/Freq);
  If Channel>3 then Begin
    DMALength:=DMALength div 2;
    PageAdress:=PageAdress div 2;
    If Odd(PageNr) then Begin
      Dec(PageNr);
      PageAdress:=PageAdress+$8000
    End;
  End;

  If EnteteRiff.NbrCanaux=2 then Begin
    If EnteteRiff.NbrBit=16 then
      Blaster_Command($A4)
    else
      Blaster_Command($A8);
  End Else If EnteteRiff.NbrBit=16 then Blaster_Command($A4);

  Dec(DMALength);

  Port[DMA_dat[Channel,1]] := $4 or (Channel and $3);
  Port[DMA_dat[Channel,2]] := $0;
  Port[DMA_dat[Channel,3]] := $49;
  Port[DMA_dat[Channel,4]] := lo(PageAdress);
  Port[DMA_dat[Channel,4]] := hi(PageAdress);
  Port[DMA_dat[Channel,5]] := lo(PageNr);
  Port[DMA_dat[Channel,6]] := lo(DMALength);
  Port[DMA_dat[Channel,6]] := hi(DMALength);
  Port[DMA_dat[Channel,1]] := (Channel and $3);

  Blaster_Command($40);
  Blaster_Command(Lo(Freq));
  Blaster_Command($48);
  Blaster_Command(lo(DMALength));
  Blaster_Command(hi(DMALength));
  Blaster_Command($91);

  STI;
End;

Procedure Ausgabe_IRQ; Interrupt; Var TmpO: Byte; Begin
  CLI;

  Port[$20] := $20;
  TmpO := Port [PortSB +$0E];

  Ende := True;

  STI;
End;
{$F-}

Procedure LitSonWav;
Var
  p,s,s2 : Word;
  w      : LongInt;
  SauvePosFich: LongInt;
  LargBarre: Byte;
Begin
  EcriTc ('Lecture : ',15);

  GetMem(zwi,16);
  GetMem(dma_buf_1,_DmaDefaut);
  p:=16;
  While (Seg(dma_buf_1^[1]) and 4095) > (4096-(_DmaDefaut shl 1 shr 4 {*2/16})) do Begin
    FreeMem(dma_buf_1,_DmaDefaut);
    FreeMem(zwi,p);
    If LongInt(p+16)>$FFFF then halt (111);
    inc (p,16);
    GetMem(zwi,p);
    GetMem(dma_buf_1,_DmaDefaut);
  End;

  GetMem(dma_buf_2,_DmaDefaut);
  FreeMem(zwi,p);
  port[$21]:=Port[$21] and (255 xor (1 shl Blaster.IRQ));
  GetIntVec(Blaster.IRQ+8,SauveInt);
  SetIntVec(Blaster.IRQ+8,@Ausgabe_IRQ);

  w:=EnteteRiff.Frequence*EnteteRiff.NbrCanaux;
  SauvePosFich := FilePos(F);
  BlockRead(F,dma_buf_1^[1],_DmaDefaut,s);

  { Prpare la barre d'avancement }
  SauvePosCurTxt;
  LargBarre := 80-EcranX;
  EcriTh (LargBarre,''); CurseurOff;

  Repeat
    { Actualise la barre d'avancement }
    RemetPosCurTxt;
    EcriThc ((FilePos(F)-SauvePosFich)*LargBarre div (FileSize(F)-SauvePosFich),'',10);

    Ende:=False;
    Stelle_DMA(w,s);
    BlockRead(F,dma_buf_2^[1],_DmaDefaut,s2);
    Repeat Until Ende;
    s:=s2;
    zwi:=dma_buf_1;
    dma_buf_1:=dma_buf_2;
    dma_buf_2:=zwi;
  Until EoF(F) or TouchPresse;

  While TouchPresse do LitTouche;

  If EoF(F) then Begin
    Ende := False;
    Stelle_DMA(w,s);
    Repeat Until Ende;
  End;

  SetintVec(Blaster.IRQ+8,SauveInt);
  FreeMem(dma_buf_1,_DmaDefaut);
  FreeMem(dma_buf_2,_DmaDefaut);
  Port[$21]:=Port[$21] or (1 shl Blaster.IRQ);
  Blaster_Command($D3);
  SauteLigne;
  Writeln ('fin');
End;

Begin
  Init;

  LitSonWav;
End.